---
title: MediaStream.getVideoTracks()
slug: Web/API/MediaStream/getVideoTracks
tags:
  - API
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - MediaStream
  - Method
  - Reference
  - Video
  - getVideoTracks
  - stream
  - track
---
<p>{{APIRef("Media Capture and Streams")}}</p>

<p>The <strong><code>getVideoTracks()</code></strong> method of the {{domxref("MediaStream")}} interface returns a sequence of {{domxref("MediaStreamTrack")}} objects representing the video tracks in this stream.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>mediaStreamTracks[]</em> = <em>mediaStream</em>.getVideoTracks();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value"><span style='font-family: x-locale-heading-primary,zillaslab,Palatino,"Palatino Linotype",x-locale-heading-secondary,serif; font-size: 1.375rem;'>Return value</span></h3>

<p>An array of {{domxref("MediaStreamTrack")}} objects, one for each video track contained in the media stream. Video tracks are those tracks whose {{domxref("MediaStreamTrack.kind", "kind")}} property is <code>video</code>. The array is empty if the stream contains no video tracks.</p>

<div class="note">
<p><strong>Note:</strong> The order of the tracks is not defined by the specification, and may not be the same from one call to <code>getVideoTracks()</code> to another.</p>
</div>

<p>Early versions of this API included a special <code>VideoStreamTrack</code> interface which was used as the type for each entry in the list of video streams; however, this has since been merged into the main {{domxref("MediaStreamTrack")}} interface.</p>

<h2 id="Example">Example</h2>

<p>The following example, extracted from <a href="https://googlechrome.github.io/samples/image-capture/photo-resolution.html">Chrome's Image Capture / Photo Resolution Sample</a>, uses <code>getVideoTracks()</code> to retrieve a track for passing to the {{domxref("ImageCapture.ImageCapture", "ImageCapture()")}} constructor. </p>

<pre class="brush: js">var imageCapture;

navigator.mediaDevices.getUserMedia({video: true})
.then(mediaStream =&gt; {
  document.querySelector('video').srcObject = mediaStream;

  const track = mediaStream.getVideoTracks()[0];
  imageCapture = new ImageCapture(track);

  return imageCapture.getPhotoCapabilities();
})</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture','#dom-mediastream-getvideotracks','getVideoTracks()')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MediaStream.getVideoTracks")}}</p>
</div>
